----------------------------------------------------------------------------
-----  AddOn:			ReadySetDing								--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----  Author:			Ketho (EU-Boulderfist Alliance CHN)			--------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----  Creation Date:	2010.01.04 (4 January 2010)					--------						(It's called Siege Engine)
-----  Text Editor:		Notepad++									--------	http://notepad-plus.sourceforge.net/
----------------------------------------------------------------------------
-----  # Version													--------
-----  ReadySetDing								v0.4 [2010.03.18]	--------	http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
-----  Ace3 Development Framework				r907 [2009.12.16]	--------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
----------------------------------------------------------------------------
-----  # Features:													--------
-----  - Announce Time Taken for Ding								--------
-----  - Compare Leveling Speed*									--------
----------------------------------------------------------------------------
-----  # Useful Sites												--------
-----  WoWWiki														--------	http://www.wowwiki.com/
-----  WoW Programming												--------	http://wowprogramming.com/
-----  lua-users													--------	http://lua-users.org/
-----  WowAce														--------	http://www.wowace.com/
-----  Wowhead														--------	http://www.wowhead.com/
----------------------------------------------------------------------------
-----  # Version History											--------
-----  v0.4	Added Custom Ding Message, Screenshot option			--------	2010.03.18
-----  v0.3	Added GUI Options, Slash Commands, embeded Ace3 libs	--------	2010.01.29
-----  v0.2 Released again, made some error							--------	2010.01.10
-----  v0.1	Release													--------	2010.01.10
----------------------------------------------------------------------------
-----  01) INITIALIZATION: OPTIONS AND DEFAULT VARIABLES			--------	Line   92~
-----  02) INITIALIZATION: OnInitialize, OnEnable, OnDisable		--------	Line  257~
-----  03) CALLBACK FUNCTIONS										--------	Line  353~
-----  04) EVENT FUNCTIONS											--------	Line  413~
----------------------------------------------------------------------------
-----  # ToDo:
-----  01A) Auto-Gratz to Party member ding -- no event that fires; use table to see difference?
-----  01B) Auto-Gratz to Guild member ding
-----  02) Random Custom Ding messages
-----  03) Compare leveling speed with guild/server
-----  04) Maybe add Instance TimeRun announce
-----  A1) Localization
-----  B1) Filter /played message at login/start of game -- possible?
-----  B2) "patterns" in lowercase/uppercase
-----  C1) option to disable ding for LV10,20,30,... since achiev
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--- Instance of AceAddon Class  ---
ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceConsole-3.0", "AceEvent-3.0")

-- Callback Function -- placed up here, because needed it just for [Blizzard GUI Options, description01]; so it'll adjust with Cataclysm when it comes
local function RSD_TimetoString(time) -- 2 most significant Units of Time
	local seconds = mod(floor(time),60);
	local minutes = mod(floor(time/60),60);
	local hours = mod(floor(time/3600),24);
	local days = floor(time/(86400));
	if (time < 60) then
		if		(seconds > 1)					then return ""..seconds.." seconds";
		elseif	(seconds == 1)					then return ""..seconds.." second"; -- mayb if some1 uses Recruit-a-Friend(RAF) level granting
		elseif	(seconds == 0)					then return "an instant"; -- lol
		end
	elseif (time >= 60 and time < 3600) then
		if		(minutes ~= 1 and seconds > 1)	then return ""..minutes.." minutes, "..seconds.." seconds";
		elseif	(minutes == 1 and seconds > 1)	then return ""..minutes.." minute, "..seconds.." seconds";
		elseif	(minutes ~= 1 and seconds == 1)	then return ""..minutes.." minutes, "..seconds.." second";
		elseif	(minutes == 1 and seconds == 1)	then return ""..minutes.." minute, "..seconds.." second";
		elseif	(minutes == 1 and seconds == 0)	then return ""..minutes.." minute";
		elseif	(minutes ~= 1 and seconds == 0)	then return ""..minutes.." minutes";
		end
	elseif (time >= 3600 and time < 86400) then
		if		(hours ~= 1 and minutes > 1)	then return ""..hours.." hours, "..minutes.." minutes";
		elseif	(hours == 1 and minutes > 1)	then return ""..hours.." hour, "..minutes.." minutes";
		elseif	(hours ~= 1 and minutes == 1)	then return ""..hours.." hours, "..minutes.." minute";
		elseif	(hours == 1 and minutes == 1)	then return ""..hours.." hour, "..minutes.." minute";
		elseif	(hours == 1 and minutes == 0)	then return ""..hours.." hour";
		elseif	(hours ~= 1 and minutes == 0)	then return ""..hours.." hours";
		end
	elseif (time >= 86400) then
		if		(days ~= 1 and hours > 1)		then return ""..days.." days, "..hours.." hours";
		elseif	(days == 1 and hours > 1)		then return ""..days.." day, "..hours.." hours";
		elseif	(days ~= 1 and hours == 1)		then return ""..days.." days, "..hours.." hour";
		elseif	(days == 1 and hours == 1)		then return ""..days.." day, "..hours.." hour";
		elseif	(days == 1 and hours == 0)		then return ""..days.." day";
		elseif	(days ~= 1 and hours == 0)		then return ""..days.." days";
		end
	end
end

RSD_expansionLevel = GetAccountExpansionLevel() -- also placed up here, because needed it just for [Blizzard GUI Options, description01]
if		RSD_expansionLevel == 0 then RSD_expansionLevelMathRandom = math.random(2, 60);
elseif	RSD_expansionLevel == 1 then RSD_expansionLevelMathRandom = math.random(2, 70);
elseif	RSD_expansionLevel == 2 then RSD_expansionLevelMathRandom = math.random(2, 80);
elseif 	RSD_expansionLevel == 3 then RSD_expansionLevelMathRandom = math.random(2, 85);
end

---- 01) INITIALIZATION: OPTIONS AND DEFAULT VARIABLES ----
--- Blizzard GUI Options ---
function ReadySetDing:BlizzOptions(input)
	-- Process the slash command ('input' contains whatever follows the slash command)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
--	else
--		LibStub("AceConfigCmd-3.0").HandleCommand(ReadySetDing, "ReadySetDing", "rsd", input)
	end
end

local options = {
    name = "ReadySet\124cffFFFFFFDing\124r \124cffB6CA00v0.4\124r \124TInterface\\Icons\\Spell_Holy_BorrowedTime:20\124t", -- Position: TopLeft Corner of ReadySetDing Options; <version>
    handler = ReadySetDing,
    type = 'group',
    args = {
		toggleEnableAddOn = {
			type = "toggle",
			order = 1,
			name = "\124cffFBDB00Enable\124r AddOn",
			descStyle = "no tooltip plz",
			width = "double",
			get = "GetEnableAddOn",
			set = "SetEnableAddOn",
		},
		toggleNormalAnnounce = {
            type = "toggle",
			order = 2,
            name = "Announce to Say/\124cff7E74BBParty\124r\124r",
			width = "full",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetNormalAnnounce",
            set = "SetNormalAnnounce",
		},
		toggleGuildAnnounce = {
            type = "toggle",
			order = 3,
			width = "full",
            name = "Announce to \124cff42E33DGuild\124r",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabledGuild",
            get = "GetGuildAnnounce",
            set = "SetGuildAnnounce",
		},
		toggleTotalTimePlayed = {
            type = "toggle",
			order = 4,
			width = "full",
            name = "Include Total Time Played",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetTotalTimePlayed",
            set = "SetTotalTimePlayed",
		},
		toggleScreenshot = {
            type = "toggle",
			order = 5,
			width = "full",
            name = "\124TInterface\\Icons\\inv_misc_spyglass_03:25\124t Take Screenshot",
			descStyle = "no tooltip plz",
			disabled = "OptionsDisabled",
            get = "GetScreenshot",
            set = "SetScreenshot",
		},
		inputDingMessage = {
            type = "input",
			order = 6,
			width  = "full",
            name = "Ding Message",
            usage = "\n\124cffffffff[LEVEL]\124r = Your new level\n\124cffffffff[TIME]\124r = Time taken last level\n\124cffffffff[TOTAL]\124r = Total time taken\nMake sure to press \124cffFFFFFF[Enter]\124r / \124cffFFFFFF[Okay]\124r",
			disabled = "OptionsDisabled",
			get = "GetInputDingMessage",
            set = "SetInputDingMessage",
        },
		description01 = {
			type = "description",
			order = 7,
			name = "\124cffB6CA00Example:\124r Ding! Level "..RSD_expansionLevelMathRandom.." in "..RSD_TimetoString(math.random(1800, 18000)), -- between half hour and 5 hours
		},
		description02 = {
			type = "description",
			order = 8,
			name = "\124cffB6CA00Commands:\124r \124cffFBDB00/rsd\124r, \124cffFBDB00/readysetding\124r",
		},
		header01 = {
			type = "header",
			order = 9,
			name = "",
		},
		executeReset = {
			type = "execute",
			order = 10,
			confirm = true,
			confirmText = "Reset to Defaults? \124TInterface\\Icons\\INV_Misc_Rune_01:18\124t",
			name = "\124cffFFFFFFReset to Defaults\124r",
			func = "ResetOptions",
			disabled = "OptionsDisabled",
		},
    },
}

--- Blizzard GUI Options GET/SET Handlers ---
function ReadySetDing:GetEnableAddOn(info) -- 01 enableAddOn GET
	return self.db.profile.enableAddOn
end
function ReadySetDing:SetEnableAddOn(info, value) -- 01~ SET
	self.db.profile.enableAddOn = value
	if (self.db.profile.enableAddOn == true) and (RSD_noDingTotalTimeLevel == nil) then
		RequestTimePlayed(); -- fetch "timePlayed" if Player decides to enable AddOn again
	end
end
function ReadySetDing:GetNormalAnnounce(info) -- 02 normalAnnounce GET
    return self.db.profile.normalAnnounce
end
function ReadySetDing:SetNormalAnnounce(info, value) -- 02~ SET
    self.db.profile.normalAnnounce = value
end
function ReadySetDing:GetGuildAnnounce(info) -- 03 guildAnnounce GET
    return self.db.profile.guildAnnounce
end
function ReadySetDing:SetGuildAnnounce(info, value) -- 03~ SET
    self.db.profile.guildAnnounce = value
end
function ReadySetDing:GetTotalTimePlayed(info) -- 04 totalTimePlayed GET
    return self.db.profile.totalTimePlayed
end
function ReadySetDing:SetTotalTimePlayed(info, value) -- 04~ SET
    self.db.profile.totalTimePlayed = value
	if		(self.db.profile.totalTimePlayed == true) then	self.db.profile.dingMessage = "Ding! Level [LEVEL] in [TIME]; [TOTAL] total time played";
	elseif	(self.db.profile.totalTimePlayed == false) then	self.db.profile.dingMessage = "Ding! Level [LEVEL] in [TIME]";
	end
end
function ReadySetDing:GetScreenshot(info) -- 05 Screenshot GET
    return self.db.profile.Screenshot
end
function ReadySetDing:SetScreenshot(info, value) -- 05~ SET
    self.db.profile.Screenshot = value
end
function ReadySetDing:GetInputDingMessage(info) -- 06 dingMessage GET
    return self.db.profile.dingMessage
end
function ReadySetDing:SetInputDingMessage(info, newValue) -- 06~ SET
    self.db.profile.dingMessage = newValue
	if (ReadySetDing:GetInputDingMessage(info) == "") or (ReadySetDing:GetInputDingMessage(info) == " ") then
		if		(ReadySetDing:GetTotalTimePlayed(info) == true) then	self.db.profile.dingMessage = "Ding! Level [LEVEL] in [TIME]; [TOTAL] total time played";
		elseif	(ReadySetDing:GetTotalTimePlayed(info) == false) then	self.db.profile.dingMessage = "Ding! Level [LEVEL] in [TIME]";
		end
	end
	RSD_validateDingMessage() -- check if typed dingMessage wrong, otherwise show error to local chat
end

--- Blizzard GUI Default Options ---
local defaults = {
    profile = {
        enableAddOn = true,								-- 01
        normalAnnounce = true,							-- 02
        guildAnnounce = false,							-- 03
        totalTimePlayed = false,						-- 04
		Screenshot = false,								-- 05
		dingMessage = "Ding! Level [LEVEL] in [TIME]",	-- 06
    },
}

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---- 02) INITIALIZATION: OnInitialize, OnEnable, OnDisable ----

function ReadySetDing:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ReadySetDing", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ReadySetDing", "ReadySet\124cffFFFFFFDing\124r \124TInterface\\Icons\\Spell_Holy_BorrowedTime:18\124t") -- Position: In Blizzard AddOn Options List; <Icon>

--- Subscribe to Events ---
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
--	self:RegisterEvent("GUILD_ROSTER_UPDATE")

--- /Slash Commands ---
	self:RegisterChatCommand("rsd", "BlizzOptions")
--	self:RegisterChatCommand("rsdtest", "testMessage") -- testing purpose
	self:RegisterChatCommand("rdy", "BlizzOptions") -- will be used enough?
	self:RegisterChatCommand("readyset", "BlizzOptions")
	self:RegisterChatCommand("readysetding", "BlizzOptions")

--- Settings ---
	SetCVar("cameraDistanceMax",50); -- Max Camera Distance ...
	
--- Not yet Implemented ---
	-- UnitXP("unit")
	-- UnitXPMax("unit")
	-- GetGuildRosterInfo(index)
	-- GetGuildRosterSelection()
	-- GetNumGuildMembers(offline)
	-- GuildRoster()
	-- IsGuildLeader("name")
	-- SetGuildRosterSelection(index)
	-- SortGuildRoster("sort")
end

function ReadySetDing:OnEnable()
	-- Called when the addon is enabled

--- Player Info ---
	RSD_playerName = UnitName("player"); -- Name of Player
--	englishFactionPlayer, localizedFactionPlayer = UnitFactionGroup("player");	-- Faction of Player
	RSD_localizedClassPlayer, RSD_englishClassPlayer = UnitClass("player");	-- Class of Player
	RSD_playerLevel = UnitLevel("player"); -- Level of Player

-- Player Class Colours (HEX); For showing coloured in local chat. dont want to keep requerying ..
	if		(RSD_englishClassPlayer == "DEATHKNIGHT") then	RSD_playerClassHEX = "C41F3B"; -- taken from: http://www.wowwiki.com/Class
	elseif	(RSD_englishClassPlayer == "DRUID") then		RSD_playerClassHEX = "FF7D0A";
	elseif	(RSD_englishClassPlayer == "HUNTER") then		RSD_playerClassHEX = "ABD473";
	elseif	(RSD_englishClassPlayer == "MAGE") then			RSD_playerClassHEX = "69CCF0";
	elseif	(RSD_englishClassPlayer == "PALADIN") then		RSD_playerClassHEX = "F58CBA";
	elseif	(RSD_englishClassPlayer == "PRIEST") then		RSD_playerClassHEX = "FFFFFF";
	elseif	(RSD_englishClassPlayer == "ROGUE") then		RSD_playerClassHEX = "FFF569";
	elseif	(RSD_englishClassPlayer == "SHAMAN") then		RSD_playerClassHEX = "2459FF";
	elseif	(RSD_englishClassPlayer == "WARLOCK") then		RSD_playerClassHEX = "9482C9";
	elseif	(RSD_englishClassPlayer == "WARRIOR") then		RSD_playerClassHEX = "C79C6E";
	else RSD_playerClassHEX = "FFFFFF"; -- Colour White
	end

--- Guild Info ---
	RSD_numGuildMembers = GetNumGuildMembers();
	
--[[
--- FILTER --- /played message at start
local function RSD_ChatFilter(self, event, msg, author, ...)
	if (playerDinged == nil or playerDinged == false) then return true
	else	return false
	end
-- ChatFrame_RemoveMessageEventFilter("TIME_PLAYED_MSG", RSD_ChatFilter)
end
ChatFrame_AddMessageEventFilter("TIME_PLAYED_MSG", RSD_ChatFilter)
--]]

--- Level Check & AccountExpansionLevel
	if ((RSD_playerLevel == 60 and RSD_expansionLevel == 0) or -- World of Warcraft (Vanilla)
		(RSD_playerLevel == 70 and RSD_expansionLevel == 1) or -- Burning Crusade
		(RSD_playerLevel == 80 and RSD_expansionLevel == 2) or -- Wrath of the Lich King; playing WotLK @ time of writing
		(RSD_playerLevel == 85 and RSD_expansionLevel == 3))   -- Cataclysm
		then	-- self.db.profile.enableAddOn = false; -- turn AddOn off, if player can't level anymore. better not do that, options are account specific..
	else	if (ReadySetDing:GetEnableAddOn(info) == true) then	RequestTimePlayed();	-- First timePlayed variable. Question: is it possible to filter an event u called urself? >> RequestTimePlayed()
			end
	end
end

function ReadySetDing:OnDisable()
	-- Called when the addon is disabled
	
--- Unsubscribe from Events (redundant with Ace3 ?) ---
    self:UnRegisterEvent("PLAYER_LEVEL_UP")
	self:UnRegisterEvent("TIME_PLAYED_MSG")
	self:UnRegisterEvent("PARTY_MEMBERS_CHANGED")
--	self:UnRegisterEvent("GUILD_ROSTER_UPDATE")
	
	self:Print("\124cffFFFF3F[ReadySetDing]\124r: \124cffFF2424Disabled\124r (OnDisable)")
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
---- 03) CALLBACK FUNCTIONS ----

function ReadySetDing:ResetOptions() -- Reverts back to [Blizzard GUI Default Options] with [Reset to Defaults] button
	self.db.profile.normalAnnounce = true;							-- 02
	self.db.profile.guildAnnounce = false;							-- 03
	self.db.profile.totalTimePlayed = false;						-- 04
	self.db.profile.Screenshot = false;								-- 05
	self.db.profile.dingMessage = "Ding! Level [LEVEL] in [TIME]";	-- 06
end

function ReadySetDing:OptionsDisabled() -- Disables(gray out) options if AddOn "disabled"
	if (ReadySetDing:GetEnableAddOn(info) == true) then return false;
	elseif (ReadySetDing:GetEnableAddOn(info) == false) then return true;
	end
end

function ReadySetDing:OptionsDisabledGuild() -- Disables(gray out) options if AddOn "disabled" or not in Guild
	if (ReadySetDing:GetEnableAddOn(info) == false or IsInGuild() ~= 1) then return true;
	elseif (ReadySetDing:GetEnableAddOn(info) == true) then return false;
	end
end

function RSD_Screenshot() -- take screenshot
	if ReadySetDing:GetScreenshot(info) == true then Screenshot() -- maybe delay a bit to show levelup animation / ding message?
	end
end

function RSD_validateDingMessage() -- Validate / check for errors
	if	string.find(ReadySetDing:GetInputDingMessage(info), "%[LEVEL%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[level%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[Level%]") == nil	then RSD_validateLevel = false;	else RSD_validateLevel = true; end
	if	string.find(ReadySetDing:GetInputDingMessage(info), "%[TIME%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[time%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[Time]") == nil		then RSD_validateTime = false;	else RSD_validateTime = true; end
	if	string.find(ReadySetDing:GetInputDingMessage(info), "%[TOTAL%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[total%]") == nil and string.find(ReadySetDing:GetInputDingMessage(info), "%[Total%]") == nil	then RSD_validateTotal = false;	else RSD_validateTotal = true; end
	-- yes, im a noob (-.-)
	if ReadySetDing:GetTotalTimePlayed(info) == false then
		if		(RSD_validateLevel == false) and (RSD_validateTime == true) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff7E74BB[LEVEL]\124r not found");
		elseif 	(RSD_validateLevel == true) and (RSD_validateTime == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff7E74BB[TIME]\124r not found");
		elseif	(RSD_validateLevel == false) and (RSD_validateTime == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff7E74BB[LEVEL]\124r, \124cff7E74BB[TIME]\124r not found");
		end
	elseif ReadySetDing:GetTotalTimePlayed(info) == true then
		if		(RSD_validateLevel == false) and (RSD_validateTime == true) and (RSD_validateTotal == true) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[LEVEL]\124r not found");
		elseif 	(RSD_validateLevel == true) and (RSD_validateTime == false) and (RSD_validateTotal == true) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[TIME]\124r not found");
		elseif	(RSD_validateLevel == true) and (RSD_validateTime == true) and (RSD_validateTotal == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[TOTAL]\124r not found");
		elseif	(RSD_validateLevel == false) and (RSD_validateTime == false) and (RSD_validateTotal == true) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[LEVEL]\124r, \124cff69CCF0[TIME]\124r not found");
		elseif	(RSD_validateLevel == false) and (RSD_validateTime == true) and (RSD_validateTotal == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[LEVEL]\124r, \124cff69CCF0[TOTAL]\124r not found");
		elseif	(RSD_validateLevel == true) and (RSD_validateTime == false) and (RSD_validateTotal == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[TIME]\124r, \124cff69CCF0[TOTAL]\124r not found");
		elseif	(RSD_validateLevel == false) and (RSD_validateTime == false) and (RSD_validateTotal == false) then	ChatFrame1:AddMessage("\124cffFBDB00ReadySetDing\124r \124cffFF0000Error:\124r \124cff69CCF0[LEVEL]\124r, \124cff69CCF0[TIME]\124r, \124cff69CCF0[TOTAL]\124r not found");
		end
	end
end

local function ReplaceText(text) -- Replace text in the Ding Message / "Globally substitute pattern for replacement in string"
	local dingMessage01a = string.gsub(ReadySetDing:GetInputDingMessage(info),"%[LEVEL%]",PLU_level); local dingMessage01b = string.gsub(dingMessage01a,"%[level%]",PLU_level); local dingMessage01c = string.gsub(dingMessage01b,"%[Level%]",PLU_level);
	local dingMessage02a = string.gsub(dingMessage01c,"%[TIME%]",RSD_TimetoString(RSD_timeDing)); local dingMessage02b = string.gsub(dingMessage02a,"%[time%]",RSD_TimetoString(RSD_timeDing)); local dingMessage02c = string.gsub(dingMessage02b,"%[Time%]",RSD_TimetoString(RSD_timeDing));
	local dingMessage03a = string.gsub(dingMessage02c,"%[TOTAL%]",RSD_TimetoString(TPM_totalTimeLevel)); local dingMessage03b = string.gsub(dingMessage03a,"%[total%]",RSD_TimetoString(TPM_totalTimeLevel)); local dingMessage03c = string.gsub(dingMessage03b,"%[Total%]",RSD_TimetoString(TPM_totalTimeLevel));
	return dingMessage03c
end

--	function ReadySetDing:testMessage() -- for Testing Purpose, /rsdtest Command to call
--		SendChatMessage(ReadySetDing:GetInputDingMessage(info), "SAY");
--	end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
---- 04) EVENT FUNCTIONS -----

function ReadySetDing:PARTY_MEMBERS_CHANGED() -- find out if in party or raid
	PMC_numPartyMembers = GetNumPartyMembers();
end

function ReadySetDing:PLAYER_LEVEL_UP(event, ...)
	PLU_level, PLU_hp, PLU_mp, PLU_talentPoints, PLU_strength, PLU_agility, PLU_stamina, PLU_intellect, PLU_spirit = select(1, ...);
	if (ReadySetDing:GetEnableAddOn(info) == true) then -- [ON / OFF] Check
		playerDinged = true; RequestTimePlayed(); --> "TIME_PLAYED_MSG" event /played
	end
end

function ReadySetDing:TIME_PLAYED_MSG(event, ...)
	TPM_totalTimeLevel, TPM_currentTimeLevel = select(1, ...);
	if (ReadySetDing:GetEnableAddOn(info) == true) then -- [ON / OFF] Check
		if (playerDinged ~= true) then
			RSD_noDingTotalTimeLevel = TPM_totalTimeLevel;
			RSD_noDingCurrentTimeLevel = TPM_currentTimeLevel;
		elseif (playerDinged == true) and (TPM_currentTimeLevel >= 0 and TPM_currentTimeLevel <= 5) and RSD_noDingTotalTimeLevel and RSD_noDingCurrentTimeLevel then
			RSD_timeDing = ((TPM_totalTimeLevel - RSD_noDingTotalTimeLevel) + RSD_noDingCurrentTimeLevel); --  the formula ..
			if (select(2, IsInInstance())) == "none" and ReadySetDing:GetNormalAnnounce(info) == true then
				if (PMC_numPartyMembers and PMC_numPartyMembers >= 1) then	SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "PARTY"); RSD_Screenshot()
				else														SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "SAY"); RSD_Screenshot()
				end
			elseif (select(2, IsInInstance())) == "party" and ReadySetDing:GetNormalAnnounce(info) == true then	SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "PARTY"); RSD_Screenshot()
			elseif (select(2, IsInInstance())) == "raid" and ReadySetDing:GetNormalAnnounce(info) == true then	SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "RAID"); RSD_Screenshot()
			elseif (select(2, IsInInstance())) == "pvp" and ReadySetDing:GetBattlegroundAnnounce(info) == true then	SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "BATTLEGROUND"); RSD_Screenshot()
			end
			if (ReadySetDing:GetGuildAnnounce(info) == true) and (IsInGuild() == 1) then	SendChatMessage(ReplaceText(ReadySetDing:GetInputDingMessage(info)), "GUILD"); if ReadySetDing:GetNormalAnnounce(info) == false then RSD_Screenshot() end
			end
			if (ReadySetDing:GetNormalAnnounce(info) == false) and (ReadySetDing:GetGuildAnnounce(info) == false or IsInGuild() ~= 1) then
				ChatFrame1:AddMessage("\124cff"..RSD_playerClassHEX.."You\124r Dinged Level "..PLU_level.." in "..RSD_TimetoString(RSD_timeDing).."! "..RSD_TimetoString(TPM_totalTimeLevel).." total time played"); RSD_Screenshot()
			end	playerDinged = false;
			RSD_noDingTotalTimeLevel = TPM_totalTimeLevel;
			RSD_noDingCurrentTimeLevel = TPM_currentTimeLevel;
		--	ChatFrame1:AddMessage("Total time played: "..TPM_totalTimeLevel); -- testing purpose
		--	ChatFrame1:AddMessage("Time played this level: "..TPM_currentTimeLevel); -- testing purpose
		end
	end
end

--[[
function ReadySetDing:GUILD_ROSTER_UPDATE()
	if (IsInGuild() == 1) then
		for i = 1, RSD_numGuildMembers do
			local GGRI_name, GGRI_rank, GGRI_rankIndex, GGRI_level, GGRI_class, GGRI_zone, GGRI_note, GGRI_officernote, GGRI_online, GGRI_status, GGRI_classFileName = GetGuildRosterInfo(i);
			GuildRosterInfo = GGRI_name.."["..i.."]-"..GGRI_level;
		--	savedNameLevel..i = GGRI_name.."-"..GGRI_level;
		end
	end
end
--]]
-------- END OF ADDON --------